(module cgi mzscheme

(provide cgi-path servername redirect web-output)

(define cgi-path
  (let ((p (or (getenv "PATH_INFO") "/")))
    (substring p 1 (string-length p))))

(define servername (or (getenv "SERVER_NAME") "undefined"))

(define (redirect url)
  (display (string-append "Cache-control: max-age=0\nExpires: 0\nLocation: " url "\n\n")))

(define (web-output body . attr)
  (if (member 'cached attr) (display "Cache-control: max-age=300\n"))
  (if (member 'uncached attr) (display "Cache-control: max-age=0\nExpires: 0\n"))
  (if (member 'plain attr) (display "Content-type: text/plain\n"))
  (if (member 'xml attr) (display "Content-type: text/xml\n\n<?xml version=\"1.0\"?>"))
  (if (member 'html attr) (display "Content-type: text/html\n"))
  (if (not (null? attr)) (newline))
  (display body))

)