(module rsssdir mzscheme
  
(require
  "rsstransforms.ss"
  (lib "1.ss" "srfi")
  (lib "pregexp.ss"))

(provide rsssdir)

(define (summarise-rsss path filename)
  (let ((rsss (call-with-input-file (string-append path "/" filename) read)))
    `(item
      (title ,(rss->title rsss))
      (link ,(pregexp-replace ".rsss$" filename ".html"))
      (description ,(rss->summary rsss)))))

(define (elements-matching matcher list)
  (filter (lambda (s) (pregexp-match matcher s)) list))

(define (rsssdir path)
  `(rss (channel
    ,@(call-with-input-file (string-append path "/about.rsssdir") read)
    ,@(map
        (lambda (f) (summarise-rsss path f))
        (elements-matching ".rsss$" (directory-list path)))))))
